/* -------------------------------------------- */
import { Misc } from "./misc.js";
import { TMRUtility } from "./tmr-utility.js";

/* -------------------------------------------- */
export class RdDItemSort extends Item {

  /* -------------------------------------------- */
  static isDifficulteVariable(sort) {
    return sort && (sort.data.difficulte.toLowerCase() == "variable");
  }

  /* -------------------------------------------- */
  static isCoutVariable(sort) {
    return sort && (sort.data.ptreve.toLowerCase() == "variable" || sort.data.ptreve.indexOf("+") >= 0);
  }
 
  /* -------------------------------------------- */
  static setCoutReveReel(sort){
    if (sort) {
      sort.data.ptreve_reel = this.isCoutVariable(sort) ? 1 : sort.data.ptreve;
    }
  }

  /* -------------------------------------------- */
  static getDifficulte(sort, variable) {
    if (sort && !RdDItemSort.isDifficulteVariable(sort)) {
       return Misc.toInt(sort.data.difficulte);
    }
    return variable;
  }

  /* -------------------------------------------- */
  static buildBonusCaseList( caseBonusString, newCase ) {
      let bonusCaseList = [];
      let bonusCaseArray = caseBonusString.split(',');
      for( let bonusCase of bonusCaseArray) {
        let bonusSplit = bonusCase.split(':');
        bonusCaseList.push( { case: bonusSplit[0], bonus: bonusSplit[1] } );
      }
      if ( newCase )
        bonusCaseList.push( {case: "Nouvelle", bonus: 0} );
      return bonusCaseList;
    }
    
  /* -------------------------------------------- */
  /**
   * Retourne une liste de bonus/case pour un item-sheet
  * @param {} item 
  */
  static getBonusCaseList( data, newCase = false ) {
          
      let bonusCaseList = [];
      // Gestion spéciale case bonus
      if ( data.item.type == 'sort') {
        bonusCaseList = this.buildBonusCaseList(data.data.bonuscase, newCase );
      }
      return bonusCaseList;
    }
    
    /* -------------------------------------------- */
    /** Met à jour les données de formulaire 
     * si static des bonus de cases sont présents 
     * */
    static buildBonusCaseStringFromFormData( formData ) {
      if ( formData.bonusValue ) {
        let list = [];
        for(let i=0; i<formData.bonusValue.length; i++) {
          let caseTMR = formData.caseValue[i] || 'A1';
          caseTMR = caseTMR.toUpperCase();
          if ( TMRUtility.verifyTMRCoord( caseTMR  ) ) { // Sanity check
            let bonus   = formData.bonusValue[i] || 0;
            list.push( caseTMR+":"+bonus );  
          }
        }
        formData.bonusValue = undefined; 
        formData.caseValue  = undefined; 
        formData['data.bonuscase'] = list.toString(); // Reset
      }
      return formData;
  }
  
  /* -------------------------------------------- */
  static incrementBonusCase( actor, sort, coordTMR ) {
      let bonusCaseList = this.buildBonusCaseList(sort.data.bonuscase, false);
      //console.log("ITEMSORT", sort, bonusCaseList);
      
      let found = false;
      let StringList = []; 
      for( let bc of bonusCaseList) {
        if (bc.case == coordTMR) { // Case existante
          found = true;
          bc.bonus = Number(bc.bonus) + 1;
        }
        StringList.push( bc.case+':'+bc.bonus );
      }
      if ( !found) { //Nouvelle case, bonus de 1
        StringList.push(coordTMR+':1');
      }
  
      // Sauvegarde/update
      let bonuscase = StringList.toString();
      //console.log("Bonus cae :", bonuscase);
      actor.updateEmbeddedEntity("OwnedItem", { _id: sort._id, 'data.bonuscase': bonuscase } );
  }
  
  /* -------------------------------------------- */
  static getCaseBonus( sort, coordTMR) {
    let bonusCaseList = this.buildBonusCaseList(sort.data.bonuscase, false);
    for( let bc of bonusCaseList) {
      if (bc.case == coordTMR) { // Case existante
        return bc.bonus;
      }
    }
    return 0;
  }

}